/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.phoenix;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.rmi.Remote;
import java.rmi.activation.ActivationSystem;
import java.rmi.server.ObjID;
import java.rmi.server.RemoteCall;
import sun.rmi.server.MarshalInputStream;
import sun.rmi.server.UnicastServerRef;
import sun.rmi.transport.LiveRef;

/**
 * JRMP exporter to export a <code>Registry</code> using the well-known
 * registry object identifier, and preventing remote code downloading for
 * incoming remote calls. This exporter implementation is only designed to
 * work with Java(TM) 2 Standard Edition implementations from Sun
 * Microsystems(TM), Inc.
 *
 * @author Sun Microsystems, Inc.
 * 
 * @since 2.0
 */
public class RegistrySunExporter extends SunJrmpExporter {
    /**
     * Creates a JRMP exporter that exports on the standard activation port
     * (1098).
     */
    public RegistrySunExporter() {
	super(ObjID.REGISTRY_ID, ActivationSystem.SYSTEM_PORT);
    }

    /**
     * Creates a JRMP exporter that exports on the specified port.
     *
     * @param port the port (if zero, an anonymous port will be chosen)
     */
    public RegistrySunExporter(int port) {
	super(ObjID.REGISTRY_ID, port);
    }

    UnicastServerRef getServerRef(LiveRef lref) {
	return new BootstrapServerRef(lref);
    }

    /**
     * Server-side ref to prevent remote code downloading when unmarshalling
     * arguments.
     */
    static class BootstrapServerRef extends UnicastServerRef {
	private static final long serialVersionUID = 3007040253722540025L;
	private static Method useCodebaseOnly;

	static {
	    try {
		useCodebaseOnly =
		    MarshalInputStream.class.getDeclaredMethod(
					     "useCodebaseOnly", null);
	    } catch (NoSuchMethodException e) {
		throw new InternalError("XXX");
	    }
	    useCodebaseOnly.setAccessible(true);
	}

	/**
	 * Construct an instance with the given live ref.
	 */
	public BootstrapServerRef(LiveRef lref) {
	    super(lref);
	}

	/**
	 * Disable remote code downloading on the input stream and then
	 * continue normal dispatching.
	 */
	public void dispatch(Remote obj, RemoteCall call) throws IOException {
	    try {
		useCodebaseOnly.invoke(call.getInputStream(), new Object[0]);
	    } catch (IllegalAccessException e) {
		throw new InternalError("XXX");
	    } catch (InvocationTargetException e) {
		throw (Error) e.getTargetException();
	    }
	    super.dispatch(obj, call);
	}
    }
}
